/**
 * @file main.c
 * @brief Este projeto demonstra os tipos de dados programados: enum, union, struct.
 * @author Wu Shin Ting
 * @date 6/09/2020
 */

#include <string.h>

// Variaveis globais de tipos de dados programados
//(G.1) Eneumeracao
/**
 * @brief Naipes de uma carta
 */
enum Napies {
	Paus, Ouros, Copas, Espadas
} carta, cp_carta;

//(G.2) Uniao
/**
 * @brief Diferentes alternativas que um valor assume
 */
union Dominio {
	char c;
	unsigned short s;
	int i;
	float f;
	double d;
} valor, *ptr_valor;

//(G.3) Struct
struct Pixel2D {
	unsigned short x;
	unsigned short y;
} pixel, cp_pixel;

/**
 * @brief Exemplos de declaracao e definicao de
 */
int main(void)
{
	// Variaveis locais de tipos de dados programados
	//(L.1) Enumeracao com inicilizacao de valores inteiros associados
	enum Booleana{Verdadeiro=1,Falso=0} checa;	
	enum Semans{Segunda=1000,Terca,Quarta,Quinta,Sexta,Sabado,Domingo} dia, *ptr_dia;
	
	//(L.2) Uniao
	union Identidade {
		unsigned int CPF;
		char nome[20];
	} pessoa;
	
	//(L.3) Struct
	struct IdentidadeS {
		unsigned int CPF;
		char nome[20];
	} pessoaS, *ptr_pessoaS;

    //(1) Atribuicao e acessos as variaveis do novo tipo baseado em enum
	// Os valores associados as variaveis sao SEMPRE inteiros
	carta = Ouros;             
	checa = Falso;
	dia = Domingo;
	
	cp_carta = carta;           // copiar o conteudo de uma variavel do tipo enum Naipes
	ptr_dia = &dia;             // copiar o endereco de uma variavel do tipo enum Semana
	
	//(2) Atribuicao e acessos as variaveis do novo tipo baseado em union
	ptr_valor = &valor;              // copiar o endereco de uma variaval tipo union Dominio
    valor.s = 256;                   // atribuir um valor a um membro da variavel do tipo union
	
	char nome[20]="Joao Maria Silva";
	pessoa.CPF = 28897651;          // atribuir um valor ao membro CPF da variavel pessoa
	strcpy(pessoa.nome, nome);      // atribuir um valor ao membro nome da variaval pessoa
	
	//(3) Atribuicao e acessos as variaveis do novo tipo baseado em struct 
	pixel.x = 20;
	pixel.y = 50;
	
	cp_pixel = pixel;              //copiar os valores de um struct
	
	char nomeS[20]="Maria Jose Silva";
	
	ptr_pessoaS = &pessoaS;	         // copiar o endereco de uma variavel do tipo struct Identidade
	ptr_pessoaS->CPF = 41234567;     // atribuir um valor ao membro CPF da variavel pessoaS pelo ponteiro
	strcpy(ptr_pessoaS->nome,nomeS); // atribuir um valor ao membro nome da variavel pessoaS pelo ponteiro
	
	//Mapeamento dos registradores do GPIOE num espaco contiguo da memoria cujo 
	//endereco inicial e 0x400FF100u
	struct GPIO_MemMap {
	  unsigned int  PDOR;                    //0x400F_F100 (deslocamento: 0x0)   
	  unsigned int  PSOR;                    //0x400F_F104 (deslocamento: 0x4)   
	  unsigned int  PCOR;                    //0x400F_F108 (deslocamento: 0x8) 
	  unsigned int  PTOR;                    //0x400F_F10C (deslocamento: 0xC)
	  unsigned int  PDIR;                    //0x400F_F110 (deslocamento: 0x10)
	  unsigned int  PDDR;                    //0x400F_F114 (deslocamento: 0x14)      
	};
	
	struct GPIO_MemMap volatile *end_gpioe;
	
	end_gpioe = (struct GPIO_MemMap volatile *)(0x400FF100u);
	
	unsigned int pdor, pdir, pddr;
	end_gpioe->PDOR |= (1<<19);
    end_gpioe->PDDR |= (1<<19);
	
	for(;;) {	   
	}
	
	return 0;
}
